function [ imc ] = erodeby( im ,n)

%'erodeby' is the function to get a maker by using the method erode
%'im' is the image which you will apply this method
%n is the size of the construction element

    m = zeros(n,n);
    m1=m;
    m1(:,uint8(n/2))=1;
    m2=m;
    m2(uint8(n/2),:)=1;
    m3=m;
    m4=m;
    for i=1:n
        m3(i,i)=1;
        m4(n+1-i,i)=1;
    end
    se1 = strel(m1);
    se2 = strel(m2);
    se3 = strel(m3);
    se4 = strel(m4);
    
    %se1 is a horizontal construction element
    %se2 is a vertical construction element
    %se3 is a construction element with a angle 45 degree 
    %se4 is a construction element with a angle 135 degree  
    
    im1 = imerode(im,se1);
    im2 = imerode(im,se2);
    im3 = imerode(im,se3);
    im4 = imerode(im,se4);
    
    
    [row,colume,z] = size(im);
    
    for i = 1:row
        for j = 1:colume
            imc(i,j) = max(im1(i,j),max(im2(i,j),max(im3(i,j),im4(i,j))));
            %imc(i,j) = min(im1(i,j),min(im2(i,j),min(im3(i,j),im4(i,j))));
        end
    end

end

