function [ im,im1,imc,imc_rc,imrecon,imbd] = segcor( im,n )
%SEGCOR Summary of this function goes here
%   'SOGCOR' can do segmentation on cornea basal cells with much noise in
%   the middle of the cells.
%   'im' is the image which you will apply this method
%   n is the size of the construction element, usually it depends on the
%   size of the noise part and the cell

    im1 = im;
    
    %Make se and se1 for the following processing(close,open,erode or dialate)
    a =zeros(5,5);
    a(a==0) = 1;
    b =zeros(2,2);
    b(b==0) = 1;
    se = strel(b);
    se1 = strel(a);
    
    %FFT filter
    im1 = filter_fft(im1);
    im1 = uint8(im1);
    
    %A close operation before processing, the target of this operation is to
    %make more connection of the margins.  
    %The size of 'se' depends on the width 'W' between the border of the cells and the border of the noise. 
    %The size of 'se' should be less than 'w'.  
    imc = imclose(im1,se);
    
    %This operation is to make the maker for the reconstruction.
    imc_rc = erodeby(imc,n);
    
    %reconstruction
    imrecon = imreconstruct(imc_rc,imc);
    
    %A close operation make the reconstructed image 'imrecon' more smooth.
    %This will be usefull when doing the watershed operation
    imbd = imclose(imrecon,se1);
    
    %Watershed
    imf = watershed(imbd,4);
    
    %Merge the orginal image with the segement result
    im(imf==0)=200;
    
    figure(1),imshow(im,[]);
    figure(2),imshow(im1,[]);
    figure(3),imshow(imc,[]);
    figure(4),imshow(imc_rc,[]);
    figure(5),imshow(imrecon,[]);
    figure(6),imshow(imf,[]);
    figure(7),imshow(imbd,[]);
    
    
end

